public class ABB {
	
	private Nodo raiz;
	
	public ABB() {
		raiz = null;
	}
	
	public boolean Esta(String _dato) {
		return Esta(_dato,raiz);
	}
	
	private boolean Esta(String _dato, Nodo _nodo) {
		if (_nodo == null)
			return false;
		if (_nodo.Dato().equals(_dato))
			return true;
		if (_nodo.Dato().compareTo(_dato) > 0)
			return Esta(_dato,_nodo.Izq());
		else
			return Esta(_dato,_nodo.Der());
	}
	
	public void Insertar(String _dato) {
		if (Esta(_dato))
			return;
		
		Nodo nuevo = new Nodo(_dato);
		
		// Buscamos nodo nodo padre del cual colgar el nodo nuevo
		Nodo actual = raiz;
		Nodo padre = null;
		while (actual != null) {
			padre = actual;
			if (actual.Dato().compareTo(nuevo.Dato()) > 0)
				actual = actual.Izq();
			else
				actual = actual.Der();
		}
		
		// Colgamos el nuevo nodo del padre
		if (padre == null)
			raiz = nuevo;
		else {
			if (padre.Dato().compareTo(nuevo.Dato()) > 0)
				padre.setIzq(nuevo);
			else
				padre.setDer(nuevo);
		}
	}
	
	public void Eliminar(String _dato) {
		if (!Esta(_dato))
			return;
		Eliminar(_dato, raiz);
	}
	
	private Nodo Eliminar(String _dato, Nodo _nodo) {
		if (_nodo == null)
			return null;
		if (_dato.equals(_nodo.Dato()))
			return unir(_nodo.Izq(), _nodo.Der());
		if (_dato.compareTo(_nodo.Dato()) < 0)
			_nodo.setIzq(Eliminar(_dato, _nodo.Izq()));
		else
			_nodo.setDer(Eliminar(_dato, _nodo.Der()));
		return _nodo;
	}
	
	private Nodo unir(Nodo izq, Nodo der) {
		if (izq == null)
			return der;
		if (der == null)
			return izq;
		Nodo centro = unir(izq.Der(), der.Izq());
		izq.setDer(centro);
		der.setIzq(izq);
		return der;
	}
	
	public void Preorden() {
		Preorden(raiz);
	}
	
	private void Preorden(Nodo _nodo) {
		if (_nodo == null)
			return;
		System.out.println(_nodo.Dato());
		Preorden(_nodo.Izq());
		Preorden(_nodo.Der());
	}
	
	public void Postorden() {
		Postorden(raiz);
	}
	
	private void Postorden(Nodo _nodo) {
		if (_nodo == null)
			return;
		Preorden(_nodo.Izq());
		Preorden(_nodo.Der());
		System.out.println(_nodo.Dato());
	}
}
